#ifndef DROP_H
#define DROP_H

#define MakePtr( cast, ptr, addValue ) (cast)( (ULONG_PTR)(ptr) + (DWORD)(addValue))

typedef struct _AppendFile
{
	ULONG signature;
	char fileName[16];
	ULONG fileSize;
	ULONG packFileSize;
} AppendFile;

typedef struct _PEInfo
{
	HANDLE hPEFile;
	HANDLE hMappedFile;
	LPVOID FileBase;
	PIMAGE_DOS_HEADER ImageDosHeader;
	PIMAGE_NT_HEADERS ImageNtHeaders;
	PIMAGE_FILE_HEADER ImageFileHeader;
	PIMAGE_OPTIONAL_HEADER ImageOptionalHeader;

	PIMAGE_SECTION_HEADER WorkingSection;
} PEInfo;

typedef struct _LoaderInfo
{
	PEInfo *pPEInfo;
	DWORD CurrentOffset;
	BYTE UnpackDir[128];
} LoaderInfo;

#ifdef __cplusplus
extern "C" {
#endif
DWORD __stdcall RvaToOffset(DWORD Rva, PIMAGE_NT_HEADERS ImageNtHeaders);
DWORD __stdcall OffsetToRva(DWORD Offset, PIMAGE_NT_HEADERS ImageNtHeaders);
PIMAGE_SECTION_HEADER __stdcall GetEnclosingSectionHeader(DWORD rva, PIMAGE_NT_HEADERS pNTHeader);
DWORD __stdcall RoundUp(DWORD value, DWORD base);
DWORD __stdcall IntervalRand(DWORD Low, DWORD High);
BOOL __stdcall ContinueWork(LoaderInfo *pInfo);
#ifdef __cplusplus
}
#endif

extern LoaderInfo g_LoaderInfo;

#endif